<template>
      <h1>Posts</h1>
      <my-input v-focus v-model="searchQuery" placeholder="Search..."/>
      <div class="app__btns">
        <my-button @click="showDialogue">Create post</my-button>
        <my-select v-model="selectedSort" :options="sortOptions"/>
      </div>
      <my-dialogue v-model:show="dialogueVisible">
        <PostForm @create="createPost" />
      </my-dialogue>
      <PostList v-if="!arePostsLoading" :posts="sortedAndFilteredPosts" @remove="removePost"/>
      <div v-else>Loading...</div>
    <div class="observer" v-intersection="loadMorePosts"></div>
    <!-- <div class="page__wrapper">
      <div
        v-for="page in totalPages" 
        class="page" 
        :class="{'current-page': page === currentPage}"
        @click="changePage(page)">
        {{page}}
      </div>
    </div> -->
  </template>
    
  <script>
    import PostForm from '@/components/PostForm.vue'
    import PostList from '@/components/PostList.vue'
  
    export default {
      components: {PostForm, PostList},
      data(){
        return {
          posts: [],
          dialogueVisible: false,
          arePostsLoading: false,
          selectedSort: '',
          searchQuery: '',
          currentPage: 1,
          pageSize: 10,
          totalPages: 0,
          sortOptions: [
            {value: 'title', name: 'Sort by title'},
            {value: 'body', name: 'Sort by body'},
            {value: 'id', name: 'Sort by id'},
          ]
        }
      },
      methods: {
        createPost(post) {
          this.posts.unshift(post)
          this.dialogueVisible = false
        },
        removePost(post) {
          this.posts = this.posts.filter(p => p.id !== post.id)
        },
        showDialogue() {
          this.dialogueVisible = true
        },
        async fetchPosts() {
          this.arePostsLoading = true
  
          try {
            const queryParams = new URLSearchParams({_page: this.currentPage, _limit: this.pageSize}).toString()
            const response = await fetch('https://jsonplaceholder.typicode.com/posts?' + queryParams, {method: 'GET'})
  
            if(!response.ok) throw new Error('Cannot get posts')
            
            this.totalPages = Math.ceil(Object.fromEntries(response.headers)['x-total-count'] / this.pageSize)
            this.posts = await response.json()
          } catch (error) {
            console.error(error)
          } finally {
            this.arePostsLoading = false
          }
        },
        async loadMorePosts() {
          this.currentPage += 1
  
          try {
            const queryParams = new URLSearchParams({_page: this.currentPage, _limit: this.pageSize}).toString()
            const response = await fetch('https://jsonplaceholder.typicode.com/posts?' + queryParams, {method: 'GET'})
  
            if(!response.ok) throw new Error('Cannot get posts')
            
            this.totalPages = Math.ceil(Object.fromEntries(response.headers)['x-total-count'] / this.pageSize)
            const newPosts = await response.json()
            console.log(newPosts)
            this.posts = [...this.posts, ...newPosts]
          } catch (error) {
            console.error(error)
          }
        },
        // changePage(newPage) {
        //   this.currentPage = newPage
        // }
      },
      computed: {
        sortedPosts() {
          return [...this.posts].sort((a,b) => {
            const aProperty = a[this.selectedSort]
            const bProperty = b[this.selectedSort]
  
            return typeof aProperty === 'number' ? aProperty - bProperty : aProperty?.localeCompare(bProperty)
          })
        },
        sortedAndFilteredPosts() {
          return this.sortedPosts.filter(post => post.title.includes(this.searchQuery))
        },
      },
      watch: {
        // currentPage: {
        //   handler() {
        //     this.fetchPosts()
        //   },
        //   immediate: true
        // }
      }
    }
  </script>
  
  <style scoped>
  .app__btns {
    margin: 15px 0;
    display: flex;
    justify-content: space-between;
  }
  
  .page__wrapper {
    display: flex;
    margin-top: 15px;
  }
  
  .page {
    border: 1px solid black;
    padding: 10px;
  }
  
  .current-page {
    border: 2px solid teal;
  }
  </style>
  